#!/usr/bin/perl -w
use strict;
use warnings;

system("mkdir -p lib");
system("make -C src");

use inc::Module::Install;


 name          'Swig_GSL';
 all_from      'lib/Simusol/Swig_GSL.pm';
 version       '0.1';
 license       'gpl3';
 requires      'File::Spec' => '0.80';
 test_requires 'Test::More' => '0.47';


 WriteAll;



use ExtUtils::MakeMaker;
use Config;


WriteMakefile(
    NAME         => 'Swig_GSL',
    VERSION      => 0.1, # finds \$VERSION
    AUTHOR       => 'Diego Saravia (Diego.Saravia@gmail.com)',
    ABSTRACT => 'Modulo Swig gsl para simusol',
    PREREQ_PM    => {
                     'Test::Simple' => 0.44,
    },
    OBJECT  => '',  # Object files
    INSTALLSCRIPT => "$ENV{HOME}/bin",
    META_MERGE => {
        resources => {
            repository => 'https://simusol.org/users/loli2/project/Exprtk'
        }
    },  
    CONFIGURE_REQUIRES => {
    },
);
