#http://www.cems.uvm.edu/~tlakoba/math337/notes_5.pdf
use List::MoreUtils qw(uniq);
use Data::Dumper;
use Exprtk;
use strict;



#=========================================================================================== DATOS
       #funciones
      
       my $funciones={};
       $funciones->{'cuad'}=['cuad',"x*x",1];

    # Variables
       my $varsh;

       $varsh->{'UNO'}->{'arr'}->[5]='N';
       $varsh->{'DOS'}->{'arr'}->[5]='N';
       $varsh->{'TRES'}->{'arr'}->[5]='N';
       $varsh->{'CUATRO'}->{'arr'}->[5]='N';
       $varsh->{'CINCO'}->{'arr'}->[5]='P';
       $varsh->{'CINCO'}->{'arr'}->[6]=0.5;
       $varsh->{'SEIS'}->{'arr'}->[5]='N';

    # Ecuaciones
       my $eqsa;

       # Exprtk
       my $nec=Exprtk::nuevaecuacion($eqsa);
       # podriamos poner 0 y listo
       $eqsa->[$nec]->{'eq'}='cuad(UNO)+4*DOS-1 + hyu';
       $eqsa->[$nec]->{'vars'}=['UNO','DOS'];
       $eqsa->[$nec]->{'res'}='0';
       $eqsa->[$nec]->{'tipo'}='N';

       # Lineales
       my $nec=Exprtk::nuevaecuacion($eqsa);
       $eqsa->[$nec]->{'vec'}=[ 3,4, 0,5];
       $eqsa->[$nec]->{'indep'}=2;
       $eqsa->[$nec]->{'vars'}=['TRES','CUATRO','CINCO','UNO'];
       $eqsa->[$nec]->{'res'}='0';
       $eqsa->[$nec]->{'nucleo'}='1';
       $eqsa->[$nec]->{'tipo'}='N';

       my $nec=Exprtk::nuevaecuacion($eqsa);
       $eqsa->[$nec]->{'vec'}=[-2,3,-1,7];
       $eqsa->[$nec]->{'indep'}=1;
       $eqsa->[$nec]->{'vars'}=['TRES','CUATRO','CINCO','UNO'];
       $eqsa->[$nec]->{'res'}='0';
       $eqsa->[$nec]->{'nucleo'}='1';
       $eqsa->[$nec]->{'tipo'}='N';

       my $nec=Exprtk::nuevaecuacion($eqsa);
       $eqsa->[$nec]->{'vec'}=[ 3,2, 1,4];
       $eqsa->[$nec]->{'indep'}=1;
       $eqsa->[$nec]->{'vars'}=['TRES','CUATRO','CINCO','UNO'];
       $eqsa->[$nec]->{'res'}='0';
       $eqsa->[$nec]->{'tipo'}='N';

       # Constantes
       my $constantes={};
       $constantes->{'hyu'}=0.12;

#=========================================================================================== PROCESA DATOS
my $ordenfijo;
# completa y acondiciona hash eq y var, calcula ordenfijo
($eqsa,$varsh,$ordenfijo)=math::arreglavarseq($eqsa,$varsh);




# reemplaza constantes
($eqsa,$funciones)=Exprtk::rempconst($constantes,$funciones,$eqsa);

	


### Agrega ecuaciones a Exprtk
Exprtk::addexprtk2($ordenfijo,$funciones,$eqsa);		     

### Muestra ecuaciones
math::printvareq($ordenfijo,$varsh,$eqsa);


#======================================================================== PROCESA DATOS Q PUEDEN CAMBIAR
### crea matriz de ecuaciones lineales
 my ($matriz,$indep)=math::creamatrizcero($eqsa);

my $NV=scalar @$ordenfijo; 
my $NFM=scalar @$matriz; 

# saca matriz para determinante directo
my ($intmatriz,$KKNFx,$KKNCx)=math::ecuaamatriz2(0,$NV,[],$eqsa);

# especifica parametros
my ($esp,$NP)=math::espini($ordenfijo,$varsh);

my $inicial;
for   (my $i=0; $i<$NV; $i++){ 
        $inicial->[$i]=$varsh->{$ordenfijo->[$i]}->{'arr'}->[6]
    }

my ($todasestan,$KKKKtodasestan2)=math::nofaltan($eqsa,$ordenfijo);

my $NE= scalar @$todasestan + $NFM;

#========================================================================VERIFICA QUE ECUA + PARAM = VARIA
print "NV: $NV; NE: $NE; NV-NE: ",$NV-$NE,"; NP: $NP. \n";
if ($NV-$NE!=$NP){
    print "ERROR, NP no es NV - NE\n";
    exit;
}


#=========================================================================================== RESUELVE
  my ($dp)=Exprtk::calcdp($eqsa, $varsh);
         
  my ($ok,$datos)=Exprtk::buscapunto2($inicial,$ordenfijo,$matriz,$todasestan,$intmatriz,$ordenfijo,$esp,$indep,$dp);


  # imprime
  math::imprimeres($ordenfijo,$datos,1,undef);

  # verifica
  Exprtk::comprueba ($matriz,$datos,$varsh,$todasestan,$ordenfijo,$ordenfijo,$indep);
