//
%module "Simusol::Swig_GSL"
%include "typemaps.i"
%include "reference.i"
 //%apply int *OUTPUT { int *itera };
%apply int *REFERENCE { int *success };
%{
#include "../../src/simusol_gsl.h"

  
%}
//extern double Foo;

%include "../../src/simusol_gsl.h"


%inline %{


int *int_array(int size) {
   return (int *) malloc(sizeof(int)*size);
}
void int_destroy(int *a) {
   free(a);
}
void int_set(int *a, int i, int val) {
   a[i] = val;
}
int int_get(int *a, int i) {
   return a[i];
}



 double *double_array(int size) {
   return (double *) malloc(sizeof(double)*size);
}
 
void double_destroy(double *a) {
   free(a);
}
void double_set(double *a, int i, double val) {
   a[i] = val;
}
double double_get(double *a, int i) {
   return a[i];
}

/////////////////////////////////////////////////////// MAL sacar de global
 double double_get_final(double *fina, int i) {
 
   return fina[i];
}
/////////////////////////////////////////////////////// MAL sacar de global
 
char **string_array(int size) {
   return (char **) malloc(sizeof(char *)*size);
 }

void string_array_destroy(char **a) {
   // destroy con un for cada string?
   free(a);
  }

 void string_array_set(char **a, int i, char *val){ //,int size) {
   //a[i] = (char*)malloc(size*sizeof(char)+1);
   //strcpy(a[i],val);
   a[i]=val;
   //return a[i];
}

 char* string_array_get(char **a, int i) {
   return a[i];
}


 //////////////////////////

 
 double *double_matrix(int sizei, int sizej) {
   printf("SIZE %d %d\n",sizei,sizej);
   return (double *) malloc(sizeof(double)*sizei*sizej);  
}

 
 
void double_matrix_destroy(double *a) {
   free(a);
}
 void double_matrix_set(double *a, int i, int j, double val,int sizej) {
   a[i*sizej+j] = val;
}
 double double_matrix_get(double *a, int i, int j,int sizej) {
   return a[i*sizej + j];
}


 
 
int *int_matrix(int sizei, int sizej) {
   printf("SIZE %d %d\n",sizei,sizej);
   return (int *) malloc(sizeof(int)*sizei*sizej);  
}

 
 
void int_matrix_destroy(int *a) {
   free(a);
}
 void int_matrix_set(int *a, int i, int j, double val,int sizej) {
   a[i*sizej+j] = val;
}
 int int_matrix_get(int *a, int i, int j,int sizej) {
   return a[i*sizej + j];
}
 
 
%}


%perlcode %{


sub create_double_array {
 my ($array)=@_;
 my $len = scalar(@$array);
 my $ia =  Simusol::Swig_GSL::double_array($len);
 for (my $i = 0; $i < $len; $i++) {
     if (not defined $array->[$i]){
	 print "NO DEFINIDO $i $array->[$i]\n";
	 exit;
     }else{
	 Simusol::Swig_GSL::double_set($ia,$i,$array->[$i]);
     }
 }
 return $ia;
}

#############################################################################################################

sub create_double_matrix {
    my ($array)=@_;
    my $nj =0;
    my $ni=scalar @$array;
    if (defined $array->[0]){
        $nj = scalar @{$array->[0]};   # verificar que todas las filas tengan igual col, que exista col 0???
        }
    my $ia =  Simusol::Swig_GSL::double_matrix ($ni,$nj);

    print "ADD ECUA CREATE_DOUBLE_MATRIZ NI $ni NJ $nj  IA $ia\n";
 
    for (my $ii = 0; $ii < $ni; $ii++) {
        for (my $j = 0; $j < $nj; $j++) {
        Simusol::Swig_GSL::double_matrix_set($ia,$ii,$j,$array->[$ii]->[$j],$nj);
        }}
    
    return $ia;
}
###############################################################################################################3

sub create_int_matrix {
    my ($array)=@_;
    my $nj =0;
    my $ni=scalar @$array;
    if (defined $array->[0]){
        $nj = scalar @{$array->[0]};   # verificar que todas las filas tengan igual col, que exista col 0???
        }
    my $ia =  Simusol::Swig_GSL::int_matrix ($ni,$nj);

    print "ADD ECUA CREATE_INT_MATRIZ NI $ni NJ $nj  IA $ia\n";
 
    for (my $ii = 0; $ii < $ni; $ii++) {
        for (my $j = 0; $j < $nj; $j++) {
        Simusol::Swig_GSL::int_matrix_set($ia,$ii,$j,$array->[$ii]->[$j],$nj);
        }}
    
    return $ia;
}


#############################################################################################################3
sub create_int_array {
 my ($array)=@_;
 my $len = scalar(@$array);
 my $ia =  Simusol::Swig_GSL::int_array($len);
 for (my $i = 0; $i < $len; $i++) {
    Simusol::Swig_GSL::int_set($ia,$i,$array->[$i]);
 }
 return $ia;
}


######################################################
sub create_string_array {
    my ($array,$stringcarray)=@_;
    my $len = scalar(@$array);
    my $ia =  Simusol::Swig_GSL::string_array($len);
    
    for (my $i = 0; $i < $len; $i++) {
       my $lens= length($array->[$i]);
       #print "KKK $len - $lens - $i -$array->[$i]\n";
       #$stringcarray->[$i]=
       Simusol::Swig_GSL::string_array_set($ia,$i,$array->[$i]); #,$lens);
       }
 return $ia;
}


  
  %}
